searchNodes=[{"doc":"Provides a set of functions to work with imglab services.","ref":"Imglab.html","title":"Imglab","type":"module"},{"doc":"Returns a formatted URL string with the specified parameters. source_name_or_source must be a string indicating a source name or a Source struct . path must be a string indicating the path of the resource. params must be an optional keyword list with the image parameters to use. Source The first parameter can be a string with the name of the source in the case that no additional settings for the source are needed: iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&quot; Or a Source struct created with Imglab.Source.new/2 specifying additional settings for the source if needed: iex&gt; &quot;assets&quot; iex&gt; |&gt; Imglab.Source . new ( ) iex&gt; |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&quot; Secured sources You can specify a secure source and use it to generate signed URLs: iex&gt; &quot;assets&quot; iex&gt; |&gt; Imglab.Source . new ( secure_key : &quot;qxxKNvxRONOMklcGJBVczefrJnE=&quot; , secure_salt : &quot;e9bXw6/HIMGTWcmAYArHA5jpIAE=&quot; ) iex&gt; |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;signature=MX0DlvzVo39-_Dh_YqPbOnrayWVabIWaSDzi-9PfGHQ&quot; The signature query string will be automatically added to the URL. Note: secure_key and secure_salt paramaters are secrets that should not be added to the code. Please use environment vars or other secure method to use them in your project. Path The second parameter must be a string defining the path to the resource. iex&gt; Imglab . url ( &quot;assets&quot; , &quot;path/to/myimage.jpeg&quot; , width : 500 , height : 600 ) &quot;https://cdn.imglab.io/assets/path/to/myimage.jpeg?width=500&amp;height=600&quot; Params The third optional parameter is a keyword list with any desired imglab transformation parameter. Some imglab parameters use hyphens inside their names. You can use atoms with underscores, these will be normalized to the correct format used by imglab API. iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , trim : &quot;color&quot; , trim_color : &quot;orange&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;trim=color&amp;trim-color=orange&quot; Or you can define a quoted atom instead: iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , trim : &quot;color&quot; , &quot;trim-color&quot; : &quot;orange&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;trim=color&amp;trim-color=orange&quot; If no params are specified a URL without query params will be generated: iex&gt; Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg&quot;","ref":"Imglab.html#url/3","title":"Imglab.url/3","type":"function"},{"doc":"Provides a set of macros to specify color parameter values.","ref":"Imglab.Color.html","title":"Imglab.Color","type":"module"},{"doc":"Returns a named color as string. Useful to use a named color checking possible typos. Examples iex&gt; Imglab.Color . color ( &quot;blue&quot; ) &quot;blue&quot; iex&gt; Imglab.Color . color ( &quot;green&quot; ) &quot;green&quot; iex&gt; Imglab.Color . color ( &quot;white&quot; ) &quot;white&quot;","ref":"Imglab.Color.html#color/1","title":"Imglab.Color.color/1","type":"macro"},{"doc":"Returns a RGB color as string. Examples iex&gt; Imglab.Color . color ( 128 , 128 , 128 ) &quot;128,128,128&quot; iex&gt; Imglab.Color . color ( 255 , 128 , 50 ) &quot;255,128,50&quot; iex&gt; Imglab.Color . color ( 255 , 0 , 0 ) &quot;255,0,0&quot;","ref":"Imglab.Color.html#color/3","title":"Imglab.Color.color/3","type":"macro"},{"doc":"Returns a RGBA color as string. Examples iex&gt; Imglab.Color . color ( 128 , 128 , 128 , 128 ) &quot;128,128,128,128&quot; iex&gt; Imglab.Color . color ( 255 , 128 , 128 , 50 ) &quot;255,128,128,50&quot; iex&gt; Imglab.Color . color ( 255 , 128 , 0 , 0 ) &quot;255,128,0,0&quot;","ref":"Imglab.Color.html#color/4","title":"Imglab.Color.color/4","type":"macro"},{"doc":"Provides a set of macros to specify position parameter values.","ref":"Imglab.Position.html","title":"Imglab.Position","type":"module"},{"doc":"Returns a position as string. Examples iex&gt; Imglab.Position . position ( &quot;left&quot; ) &quot;left&quot; iex&gt; Imglab.Position . position ( &quot;bottom&quot; ) &quot;bottom&quot; iex&gt; Imglab.Position . position ( &quot;right&quot; ) &quot;right&quot;","ref":"Imglab.Position.html#position/1","title":"Imglab.Position.position/1","type":"macro"},{"doc":"Returns a position as string specified with horizontal and vertical values: iex&gt; Imglab.Position . position ( &quot;left&quot; , &quot;bottom&quot; ) &quot;left,bottom&quot; iex&gt; Imglab.Position . position ( &quot;center&quot; , &quot;middle&quot; ) &quot;center,middle&quot; iex&gt; Imglab.Position . position ( &quot;right&quot; , &quot;top&quot; ) &quot;right,top&quot; Or specified with vertical and horizontal values: iex&gt; Imglab.Position . position ( &quot;bottom&quot; , &quot;left&quot; ) &quot;bottom,left&quot; iex&gt; Imglab.Position . position ( &quot;middle&quot; , &quot;center&quot; ) &quot;middle,center&quot; iex&gt; Imglab.Position . position ( &quot;top&quot; , &quot;right&quot; ) &quot;top,right&quot;","ref":"Imglab.Position.html#position/2","title":"Imglab.Position.position/2","type":"macro"},{"doc":"Provides a way to define and store information about a imglab source.","ref":"Imglab.Source.html","title":"Imglab.Source","type":"module"},{"doc":"Returns a Source struct with the specified options for the source. name must be a string indicating the name of the source. Options The accepted options are: :host - a string specifying the host where the imglab server is located, only for imglab on-premises (default: &quot;cdn.imglab.io&quot; ) :https - a boolean value specifying if the source should use https or not (default: true ) :port - a :inet.port_number specifying a port where the imglab server is located, only for imglab on-premises :secure_key - a string specifying the source secure key :secure_salt - a string specifying the source secure salt :subdomains - a boolean value specifying if the source should be specified using subdomains instead of using the path, only for imglab on-premises (default: false ) Note: secure_key and secure_salt paramaters are secrets that should not be added to the code. Please use environment vars or other secure method to use them in your project. Examples iex&gt; Imglab.Source . new ( &quot;assets&quot; ) % Imglab.Source { host : &quot;cdn.imglab.io&quot; , https : true , name : &quot;assets&quot; , port : nil , secure_key : nil , secure_salt : nil , subdomains : false } iex&gt; Imglab.Source . new ( &quot;assets&quot; , subdomains : true ) % Imglab.Source { host : &quot;cdn.imglab.io&quot; , https : true , name : &quot;assets&quot; , port : nil , secure_key : nil , secure_salt : nil , subdomains : true } iex&gt; Imglab.Source . new ( &quot;assets&quot; , https : false , host : &quot;imglab.net&quot; , port : 8080 ) % Imglab.Source { host : &quot;imglab.net&quot; , https : false , name : &quot;assets&quot; , port : 8080 , secure_key : nil , secure_salt : nil , subdomains : false } iex&gt; Imglab.Source . new ( &quot;assets&quot; , secure_key : &quot;secure-key&quot; , secure_salt : &quot;secure-salt&quot; ) % Imglab.Source { host : &quot;cdn.imglab.io&quot; , https : true , name : &quot;assets&quot; , port : nil , secure_key : &quot;secure-key&quot; , secure_salt : &quot;secure-salt&quot; , subdomains : false }","ref":"Imglab.Source.html#new/2","title":"Imglab.Source.new/2","type":"function"},{"doc":"","ref":"Imglab.Source.html#t:t/0","title":"Imglab.Source.t/0","type":"type"},{"doc":"imglab is the official Elixir library to integrate with imglab services.","ref":"readme.html","title":"imglab","type":"extras"},{"doc":"Add imglab to your list of dependencies in mix.exs : def deps do [ { :imglab , &quot;~&gt; 0.1&quot; } ] end And run: $ mix deps.get","ref":"readme.html#installation","title":"imglab - Installation","type":"extras"},{"doc":"imglab has been successfully tested on the following Elixir versions: 1.13 , 1.12 , 1.11 , 1.10 , 1.9 , 1.8 , 1.7 , 1.6 , 1.5 , and 1.4 .","ref":"readme.html#elixir-compatibility","title":"imglab - Elixir compatibility","type":"extras"},{"doc":"You can use Imglab.url/3 function to generate imglab compatible URLs for your application. The easiest way to generate a URL is to specify the source_name , path and required parameters : Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&quot; Imglab . url ( &quot;avatars&quot; , &quot;user-01.jpeg&quot; , width : 300 , height : 300 , mode : :crop , crop : :face , format : :webp ) &quot;https://cdn.imglab.io/avatars/user-01.jpeg?width=300&amp;height=300&amp;mode=crop&amp;crop=face&amp;format=webp&quot; If some specific settings are required for the source you can use a Imglab.Source struct instead of a string source name: Imglab . url ( Imglab.Source . new ( &quot;assets&quot; ) , &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&quot; Using secure image sources For sources that require signed URLs you can specify secure_key and secure_salt attributes: &quot;assets&quot; |&gt; Imglab.Source . new ( secure_key : &quot;assets-secure-key&quot; , secure_salt : &quot;assets-secure-salt&quot; ) |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;signature=generated-signature&quot; signature query parameter will be automatically generated and attached to the returned URL. Note: secure_key and secure_salt attributes are secrets that should not be added to a code repository. Please use environment vars or other secure method to use them in your application. Using HTTP instead of HTTPS In the case that HTTP schema is required instead of HTTPS you can set https attribute to false when creating the source: &quot;assets&quot; |&gt; Imglab.Source . new ( https : false ) |&gt; Imglab . url ( &quot;image.jpeg&quot; , width : 500 , height : 600 ) &quot;http://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&quot; Note: HTTPS is the default and recommended way to generate URLs with imglab. Specifying parameters Any parameter from the imglab API can be used to generate URLs with Imglab.url/3 function. For parameters that required dashes characters like trim-color you can use regular underscore Elixir atoms like :trim_color those will be normalized in the URL generation to it's correct form: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , trim : &quot;color&quot; , trim_color : &quot;black&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?trim=color&amp;trim-color=black&quot; It is possible to use quoted atoms too: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , trim : &quot;color&quot; , &quot;trim-color&quot; : &quot;black&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?trim=color&amp;trim-color=black&quot; Specifying color parameters Some imglab parameters can receive a color as value. It is possible to specify these color values as strings: # Specifying a RGB color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;255,0,0&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0&quot; # Specifying a RGBA color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;255,0,0,128&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0%2C128&quot; # Specifying a named color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;red&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=red&quot; # Specifying a hexadecimal color as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : :contain , background_color : &quot;F00&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=F00&quot; You can additionally use Imglab.Color macros to specify these color values: # Remember to import Imglab.Color before use these macros import Imglab.Color # Using color macro for a RGB color Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : &quot;contain&quot; , background_color : color ( 255 , 0 , 0 ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0&quot; # Using color macro for a RGBA color Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : &quot;contain&quot; , background_color : color ( 255 , 0 , 0 , 128 ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=255%2C0%2C0%2C128&quot; # Using color macro for a named color Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , mode : &quot;contain&quot; , background_color : color ( &quot;red&quot; ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;mode=contain&amp;background-color=red&quot; Note: specify hexadecimal color values using Imglab.Color macros is not allowed. You can use strings instead. Specifying position parameters Some imglab parameters can receive a position as value. It is possible to specify these values using strings: # Specifying a horizontal and vertical position as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : &quot;left,top&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left%2Ctop&quot; # Specifying a vertical and horizontal position as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : &quot;top,left&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=top%2Cleft&quot; # Specifying a position as string Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : &quot;left&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left&quot; You can additionally use Imglab.Position macros to specify these position values: # Remember to import Imglab.Position before use these macros import Imglab.Position # Using position macro for a horizontal and vertical position Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : position ( &quot;left&quot; , &quot;top&quot; ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left%2Ctop&quot; # Using position macro for a vertical and horizontal position Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : position ( &quot;top&quot; , &quot;left&quot; ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=top%2Cleft&quot; # Using position macro for a position Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 500 , mode : &quot;crop&quot; , crop : position ( &quot;left&quot; ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=500&amp;mode=crop&amp;crop=left&quot; Specifying URL parameters Some imglab parameters can receive URLs as values. It is possible to specify these parameter values as strings. Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : &quot;logo.svg&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;watermark=logo.svg&quot; And even use parameters if required: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : &quot;logo.svg?width=100&amp;format=png&quot; ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;watermark=logo.svg%3Fwidth%3D100%26format%3Dpng&quot; Additionally you can use nested Imglab.url/3 calls to specify these URL values: Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : Imglab . url ( &quot;assets&quot; , &quot;logo.svg&quot; , width : 100 , format : &quot;png&quot; ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;watermark=https%3A%2F%2Fcdn.imglab.io%2Fassets%2Flogo.svg%3Fwidth%3D100%26format%3Dpng&quot; If the resource is located in a different source we can specify it using Imglab.url/3 : Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : Imglab . url ( &quot;marketing&quot; , &quot;logo.svg&quot; , width : 100 , format : &quot;png&quot; ) ) &quot;https://cdn.imglab.io/assets/image.jpeg?width=500&amp;height=600&amp;watermark=https%3A%2F%2Fcdn.imglab.io%2Fmarketing%2Flogo.svg%3Fwidth%3D100%26format%3Dpng&quot; Using secure sources for URLs parameter values is possible too: marketing_source = Imglab.Source . new ( &quot;marketing&quot; , secure_key : &quot;marketing-secure-key&quot; , secure_salt : &quot;marketing-secure-salt&quot; ) Imglab . url ( &quot;assets&quot; , &quot;image.jpeg&quot; , width : 500 , height : 600 , watermark : Imglab . url ( marketing_source , &quot;logo.svg&quot; , width : 100 , format : &quot;png&quot; ) ) signature query parameter will be automatically generated and attached to the nested URL value.","ref":"readme.html#generating-urls","title":"imglab - Generating URLs","type":"extras"},{"doc":"For on-premises imglab server is possible to define custom sources pointing to your server location. :https - a boolean value specifying if the source should use https or not (default: true ) :host - a string specifying the host where the imglab server is located. (default: cdn.imglab.io ) :port - a :inet.port_number specifying a port where the imglab server is located. :subdomains - a boolean value specifying if the source should be specified using subdomains instead of using the path. (default: false ) If we have our on-premises imglab server at http://imglab.mycompany.com:8080 with a source named web-images we can use the following source settings to access a logo.png image: &quot;web-images&quot; |&gt; Imglab.Source . new ( https : false , host : &quot;imglab.mycompany.com&quot; , port : 8080 ) |&gt; Imglab . url ( &quot;logo.png&quot; , width : 300 , height : 300 , format : &quot;png&quot; ) &quot;http://imglab.mycompany.com:8080/web-images/logo.png?width=300&amp;height=300&amp;format=png&quot; It is possible to use secure sources too: &quot;web-images&quot; |&gt; Imglab.Source . new ( https : false , host : &quot;imglab.mycompany.com&quot; , port : 8080 , secure_key : &quot;web-images-secure-key&quot; , secure_salt : &quot;web-images-secure-salt&quot; ) |&gt; Imglab . url ( &quot;logo.png&quot; , width : 300 , height : 300 , format : &quot;png&quot; ) &quot;http://imglab.mycompany.com:8080/web-images/logo.png?width=300&amp;height=300&amp;format=png&amp;signature=generated-signature&quot; Using sudomains sources In the case that your on-premises imglab server is configured to use source names as subdomains you can set subdomains attribute to true to generate URLs using subdomains: &quot;web-images&quot; |&gt; Imglab.Source . new ( https : false , host : &quot;imglab.mycompany.com&quot; , port : 8080 , subdomains : true ) |&gt; Imglab . url ( &quot;marketing/logo.png&quot; , width : 300 , height : 300 , format : &quot;png&quot; ) &quot;http://web-images.imglab.mycompany.com:8080/marketing/logo.png?width=300&amp;height=300&amp;format=png&quot;","ref":"readme.html#generating-urls-for-on-premises-imglab-server","title":"imglab - Generating URLs for on-premises imglab server","type":"extras"},{"doc":"imglab source code is released under MIT License .","ref":"readme.html#license","title":"imglab - License","type":"extras"},{"doc":"MIT License Copyright (c) 2021 imglab Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]